-- 微信用户和销售关系表添加项目ID
alter table fs_user_company_user
    add column project_id bigint comment '课程项目ID';

alter table fs_user_company_user add constraint uk_user_project
    unique (user_id, project_id);

alter table fs_user_company_user
    add column qw_user_id bigint comment '企微用户ID',
    add column qw_external_contact_id bigint comment '企微外部联系人ID',
    add column qw_company_id bigint comment '企微主体ID';

alter table fs_user_course_video
    add column project_id bigint comment '项目ID';

alter table fs_user_company_user
    add column status tinyint default 1 comment '状态 0小黑屋 1正常 2拉黑';

alter table fs_user_company_user
    add column remark varchar(255) comment '备注';

drop table if exists fs_user_project_tag;
create table fs_user_project_tag (
    `id`                             bigint        not null auto_increment comment '主键ID',
    `user_company_user_id`           bigint                                comment '用户项目ID',
    `tag_id`                         bigint                                comment '标签ID',
    `create_time`                    datetime                              comment '创建时间',
    primary key (`id`) using btree,
    index idx_user_company_user_id(`user_company_user_id`) using btree,
    index idx_tag_id(`tag_id`) using btree
) engine = InnoDB comment = '用户项目标签表';

alter table fs_user_company_user
    add column create_time datetime comment '创建时间';

ALTER TABLE fs_user_company_user MODIFY COLUMN create_time datetime DEFAULT now() NULL COMMENT '创建时间';

-- 补数据  中康项目ID 为5 其他项目根据情况调整
insert into `fs_user_company_user`
(`user_id`, `company_user_id`, `company_id`, `is_repeat_fans`, `project_id`, `qw_user_id`, `qw_external_contact_id`, `qw_company_id`, `status`, `remark`, `create_time`)
select user_id,company_user_id,company_id,0,5,null,null,null,`status`,remark,create_time from fs_user;

-- 补标签
INSERT INTO fs_user_project_tag (user_company_user_id, tag_id, create_time)
SELECT
    fu.id AS user_company_user_id,
    CAST(st.tag_id AS UNSIGNED) AS tag_id,
    st.create_time
FROM (
         WITH RECURSIVE split_tags AS (
             SELECT
                 id,
                 user_id,
                 company_user_id,
                 company_id,
                 create_time,
                 SUBSTRING_INDEX(tag_ids, ',', 1) AS tag_id,
                 SUBSTRING(tag_ids, LOCATE(',', tag_ids) + 1) AS rest
             FROM company_tag_user
             WHERE tag_ids IS NOT NULL AND tag_ids != ''

             UNION ALL

             SELECT
                 id,
                 user_id,
                 company_user_id,
                 company_id,
                 create_time,
                 SUBSTRING_INDEX(rest, ',', 1),
                 SUBSTRING(rest, LOCATE(',', rest) + 1)
             FROM split_tags
             WHERE rest IS NOT NULL AND rest != ''
         )
         SELECT * FROM split_tags
     ) st
         JOIN fs_user_company_user fu
              ON fu.user_id = st.user_id
                  AND fu.company_user_id = st.company_user_id
                  AND fu.company_id = st.company_id
WHERE st.tag_id REGEXP '^[0-9]+$';

